VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TextureFactory8"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'--------------------------------
'  TrueVision Texture Factory
'--------------------------------

Private LocalClass As Boolean
' Started 15/11/00






Friend Function GetNewTextureIndex() As Integer
        Dim i As Long
       Dim Format As Long
       Dim TempT As Texture8
       Set TempT = New Texture8
        
       For i = 1 To NBTexture
         If Textures(i).Enabled = False Then
             Exit For
         End If
       Next i
       If i = NBTexture + 1 Then
         NBTexture = NBTexture + 1
         ReDim Preserve Textures(NBTexture)
       End If
       Textures(i).Enabled = True
       Set Textures(i).TextureOb = TempT
       Textures(i).TextureOb.SetTexIndex i
       Textures(i).TextureName = "No need"
       GetNewTextureIndex = i
End Function

Function LoadDecalTexture(Filename As String, Optional Name As String = "", Optional width As Long = -1, Optional height As Long = -1) As Texture8
   Set LoadDecalTexture = LoadTexture(Filename, Name, width, height, TV_COLORKEY_BLACK)
   
End Function

Public Function LoadTexture(Filename As String, Optional Name As String = "", Optional width As Long = -1, Optional height As Long = -1, Optional Colorkey As CONST_TV_COLORKEY = 0) As Texture8
Attribute LoadTexture.VB_Description = "Load the specified texture and return Texture8 object."
Attribute LoadTexture.VB_UserMemId = 0
       
       On Error GoTo errtreat
       AddLog "TEXTURE FACTORY : Load texture " + CStr(Filename) + " / Name : " + CStr(Name)
       Dim i As Long
       Dim Format As Long
       Set LoadTexture = New Texture8
        
       For i = 1 To NBTexture
         If Textures(i).Enabled = False Then
             Exit For
         End If
         If Textures(i).TextureName = Name Or Textures(i).TextureFileName = Filename Then
           AddLog "TEXTURE FACTORY : Texture already loaded... Reload however."
           Exit For
         End If
       Next i
       If i = NBTexture + 1 Then
         NBTexture = NBTexture + 1
         ReDim Preserve Textures(NBTexture)
       End If
       
       
       Set Textures(i).TextureOb = LoadTexture
        
        Format = FmtTexture
        'Search the good format for the new texture (this function corrects the width, the height
        'and the format type)
        If Colorkey <> 0 Then
         
         Format = FmtAlphaTexture
         Textures(i).Colorkey = Colorkey
         Colorkey = 0
         Device.SetRenderState D3DRS_ALPHAFUNC, D3DCMP_GREATER
         Device.SetRenderState D3DRS_ALPHATESTENABLE, 1
         Device.SetRenderState D3DRS_ALPHAREF, 8
        End If
         
       Textures(i).TextureFileName = file
       D3DX.CheckTextureRequirements Device, width, height, 0, 0, Format, D3DPOOL_MANAGED
               
        TestPAKFile Filename
         Set Textures(i).TexSurf = D3DX.CreateTextureFromFileEx(Device, Filename, _
                           width, height, 0, 0, _
                          Format, D3DPOOL_MANAGED, D3DX_FILTER_LINEAR, D3DX_DEFAULT, Textures(i).Colorkey, ByVal 0, ByVal 0)
       
        DeletePAKTemp Filename
       Textures(i).TextureHeight = width
       Textures(i).TextureWidth = height
       Textures(i).TextureOb.SetTexIndex i
       Textures(i).Enabled = True
       Textures(i).TextureName = IIf(Name = "", "Texture" + CStr(i), Name)
      Set LoadTexture = Textures(i).TextureOb
        Exit Function
errtreat:
      If Err.Number = D3DERR_NOTFOUND Or Err.Number = -2147024894 Then
       AddLog "TEXTURE FACTORY : ERROR " + CStr(Filename) + " texture NOT FOUND ! "
      Else
       AddLog "TEXTURE FACTORY : ERROR " + CStr(Err.Description) + " " + CStr(Err.Number)
      End If
       Resume Next

End Function
Public Sub DeleteTexture(Texture As Texture8)
    Dim Index As Integer
    Index = Texture.GetTexIndex
    With Textures(Index)
      .Enabled = False
      .TextureName = ""
      Set .TexSurf = Nothing
      Set .TextureOb = Nothing
      Set Texture = Nothing
      Set .RTS = Nothing
    End With
End Sub

Friend Sub SetLocal()
  LocalClass = True
End Sub

Private Sub Class_Initialize()
 ' ReDim Textures(0)
End Sub



Private Sub Class_Terminate()
  On Error Resume Next
  If LocalClass = False Then

 End If
End Sub


